#include <stdio.h>
#include <sys/select.h>

int main(int argc, char *argv[])
{
  char buf[1024];
  FILE *fp = stdin;
  fd_set rfds;

  if (argc > 1)
    fp = fopen(argv[1], "r");
  if (!fp) fp = stdin;
  fseek(fp, 0, SEEK_END);
  clearerr(fp);
  while (!0) {
    while (!feof(fp)) {
      size_t size;
      size = fread(buf, sizeof(buf[0]), sizeof(buf)/sizeof(buf[0]), fp);
      if (size)
	fwrite(buf, 1, size, stdout);
    }
    FD_ZERO(&rfds);
    FD_SET(fileno(fp), &rfds);
    if (select(fileno(fp)+1, &rfds, NULL, NULL, NULL) == -1) {}
    else if (FD_ISSET(fileno(fp), &rfds))
      clearerr(fp);
  }
  return 0;
}
