/*
  deject.h

  Copyright (C) 2012 Taiji Yamada <taiji@aihara.co.jp>
 */
#ifndef _DEJECT_H_
#define _DEJECT_H_
#include <stdio.h>
#include <stdlib.h>

#define deject_if(x) do {\
  if (x) {\
    fprintf(stderr, "%s:%d: error: %s\n", __FILE__, __LINE__, #x);\
    exit(1);\
  }\
} while (0)

#endif
