/*
  verbose.h

  Copyright (C) 2012 Taiji Yamada <taiji@aihara.co.jp>
 */
#ifndef _VERBOSE_H_
#define _VERBOSE_H_

static int verbose = 0;
#define VERBOSE(x) if (verbose) do { x; } while(0)
#define SILENT(x) if (!verbose) do { x; } while(0)

#endif
